<?php

namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class Sm00006000ElementoFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    /**
     * Exclui o elemento e seus filhos.
     * 
     * @param mixed[] @params
     */
    public function excluirElementoEmCascata($params) {
        $sql = "DELETE FROM FCT_SERVICOORCA
                 WHERE NRORG      = :NRORG
                   AND CDSERVORCA IN (SELECT CDSERVORCA
                                        FROM FCT_SERVICOORCA
                                       WHERE NRORG               = :NRORG
                                       START WITH IDELEMENTO     = :IDELEMENTO
                                     CONNECT BY PRIOR IDELEMENTO = IDELEMENTOPAI)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    /**
     * 
     */
    public function salvarMedidaVariavelEmCascata($params) {
        $sql = "UPDATE FCT_SERVICOORCA
                   SET CDTPMEDIDAVARIAVEL = :CDTPMEDIDAVARIAVEL,
                   CDCENTCUST             = :CDCENTCUST
                 WHERE IDTIPO            = 'E'
                   AND NRORG             = :NRORG
                   AND IDELEMENTO        IN (SELECT IDELEMENTO
                                               FROM FCT_SERVICOORCA
                                              WHERE IDTIPO              = 'E'
                                                AND IDELEMENTO          <> :IDELEMENTO
                                                AND NRORG               = :NRORG
                                              START WITH IDELEMENTO     = :IDELEMENTO
                                            CONNECT BY PRIOR IDELEMENTO = IDELEMENTOPAI)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
     /**
     *  A função "validaIdentificador" Realiza a validação  do campo "identificador". 
     *  Não podem haver dois identificadores iguais.
     */
     
    public function validaIdentificador($params){
        
        $sql = "SELECT COUNT(*) AS VALIDA
                FROM FCT_SERVICOORCA
                WHERE IDITEMCALCULO IS NOT NULL
                AND IDITEMCALCULO = :IDITEMCALCULO 
                AND NRORG = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}

?>